unit ChangeNotifierUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SxChangeNotifier, StdCtrls, ComCtrls, ShlObj, ActiveX, Spin, ExtCtrls;

type
  TTestNotifierWindow = class(TForm)
    ChangeNotifier: TSxChangeNotifier;
    Start: TButton;
    Button1: TButton;
    ListView: TListView;
    Button2: TButton;
    btnPauseResume: TButton;
    ePath: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    WatchSub: TRadioGroup;
    levels: TSpinEdit;
    procedure StartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnPauseResumeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ChangeNotifierDelete(Sender: TObject; FileInfo: TSxFileInfoEventData);
    procedure ChangeNotifierAddFile(Sender: TObject; FileInfo: TSxFileInfoEventData);
    procedure ChangeNotifierChange(Sender: TObject; FileInfo: TSxFileInfoEventData);
    procedure FormCreate(Sender: TObject);
    procedure levelsChange(Sender: TObject);
    procedure WatchSubClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TestNotifierWindow: TTestNotifierWindow;

implementation

{$R *.DFM}

procedure TTestNotifierWindow.StartClick(Sender: TObject);
begin
  ChangeNotifier.Root:=ePath.Text;
  ChangeNotifier.Start;
end;

procedure TTestNotifierWindow.Button1Click(Sender: TObject);
begin
  ChangeNotifier.Stop;
end;

procedure TTestNotifierWindow.btnPauseResumeClick(Sender: TObject);
begin
  if not ChangeNotifier.Paused then
  begin
    ChangeNotifier.Paused:=True;
    btnPauseResume.Caption:='Resume';
  end
  else
  begin
    ChangeNotifier.Paused:=False;
    btnPauseResume.Caption:='Pause';
  end;
end;

procedure TTestNotifierWindow.Button2Click(Sender: TObject);
begin
  ListView.Items.Clear;
end;

procedure TTestNotifierWindow.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ChangeNotifier.Stop;
end;

procedure TTestNotifierWindow.ChangeNotifierDelete(Sender: TObject;
  FileInfo: TSxFileInfoEventData);
var
  ListItem:TListItem;
begin
  ListItem:=ListView.Items.Add;
  ListItem.Caption:='Deleted';
  ListItem.SubItems.Add(FileInfo.Filename);
  ListItem.SubItems.Add(DateTimeToStr(FileInfo.OldLastAccessTime));
end;

procedure TTestNotifierWindow.ChangeNotifierAddFile(Sender: TObject;
  FileInfo: TSxFileInfoEventData);
var
  ListItem:TListItem;
begin
   ListItem:=ListView.Items.Add;
   ListItem.Caption:='Created';
   ListItem.SubItems.Add(FileInfo.Filename);
   ListItem.SubItems.Add(DateTimeToStr(FileInfo.NewLastAccessTime));
end;

procedure TTestNotifierWindow.ChangeNotifierChange(Sender: TObject;
  FileInfo: TSxFileInfoEventData);
var
  ListItem:TListItem;
begin
  ListItem:=ListView.Items.Add;
  ListItem.Caption:='Modified';
  ListItem.SubItems.Add(FileInfo.Filename);
  ListItem.SubItems.Add(DateTimeToStr(FileInfo.OldLastWriteTime));
end;

procedure TTestNotifierWindow.FormCreate(Sender: TObject);
var
  Buffer:PChar;
  Folder:PItemIDList;
  Malloc:IMalloc;
  Str:String;
begin
  GetMem(Buffer,MAX_PATH);
  try
    SHGetMalloc(Malloc);
    ShGetSpecialFolderLocation(Handle,CSIDL_DESKTOP,Folder);
    SHGetPathFromIDList(Folder,Buffer);
    Str:=StringReplace(StrPas(Buffer),'\','-',[rfReplaceAll]);
    Str:=StringReplace(Str,'-','\',[rfReplaceAll]);
    ePath.Text:=Str;
    Malloc.Free(Folder);
  finally
    FreeMem(Buffer);
    levels.Value:=ChangeNotifier.MaxLevels;
    if ChangeNotifier.WatchSubtree=true then WatchSub.ItemIndex:=0
     else WatchSub.ItemIndex:=1;
    ChangeNotifier.Stop;
  end;
end;

procedure TTestNotifierWindow.levelsChange(Sender: TObject);
begin
ChangeNotifier.Stop;
ChangeNotifier.MaxLevels:=levels.Value;
//ChangeNotifier.Start;
end;

procedure TTestNotifierWindow.WatchSubClick(Sender: TObject);
begin
ChangeNotifier.Stop;
 case WatchSub.ItemIndex of
  0:ChangeNotifier.WatchSubtree:=true;
  1:ChangeNotifier.WatchSubtree:=false;
 end;
//ChangeNotifier.Start;
end;

end.
